--- /home/sfriedma/Transifex/Fedora 12/Translatables/libuser  » tip/libuser.tip.fr_Old.po	2009-12-10 14:20:58.000000000 +1000
+++ /home/sfriedma/Transifex/Fedora 12/Translatables/libuser  » tip/libuser.tip.fr.po	2009-12-14 13:57:31.000000000 +1000
@@ -1,5 +1,6 @@
+# translation of libuser.tip.fr.po to French
 # French translation of libuser
-# Copyright (C) 2001, 2004, 2005, 2007, 2008 Free Software Foundation, Inc.
+# Copyright (C) 2001, 2004, 2005, 2007, 2008, 2009 Free Software Foundation, Inc.
 # This file is distributed under the same license as the libuser package.
 #
 #
@@ -11,19 +12,20 @@
 # Robert-André Mauchin <zebob.m@pengzone.org>, 2008.
 # Charles-Antoine Couret <cacouret@wanadoo.fr>, 2009.
 # Pablo Martin-Gomez <pablo.martin-gomez@laposte.net>, 2009.
+# Sam Friedmann <sam.friedmann@redhat.com>, 2009.
 msgid ""
 msgstr ""
-"Project-Id-Version: libuser tip\n"
+"Project-Id-Version: libuser.tip.fr\n"
 "Report-Msgid-Bugs-To: http://bugzilla.redhat.com/bugzilla/\n"
 "POT-Creation-Date: 2009-12-10 02:40+0000\n"
-"PO-Revision-Date: 2009-10-28 21:15+0100\n"
-"Last-Translator: Pablo Martin-Gomez <pablo.martin-gomez@laposte.net>\n"
-"Language-Team: Français <fedora-trans-fr@redhat.com>\n"
+"PO-Revision-Date: 2009-12-14 13:57+1000\n"
+"Last-Translator: Sam Friedmann <sam.friedmann@redhat.com>\n"
+"Language-Team: French <fr@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=n > 1;\n"
-"X-Generator: Lokalize 0.3\n"
+"X-Generator: KBabel 1.11.4\n"
 
 #: ../apps/apputil.c:109
 #, c-format
@@ -371,8 +373,7 @@
 #: ../apps/lnewusers.c:118
 #, c-format
 msgid "Error creating account for `%s': line improperly formatted.\n"
-msgstr ""
-"Erreur lors de la création d'un compte pour « %s » : ligne mal formatée.\n"
+msgstr "Erreur lors de la création d'un compte pour « %s » : ligne mal formatée.\n"
 
 #: ../apps/lnewusers.c:129 ../apps/luseradd.c:116 ../apps/lusermod.c:127
 #, c-format
@@ -392,7 +393,7 @@
 #: ../apps/lnewusers.c:283
 #, c-format
 msgid "Refusing to use dangerous home directory `%s' for %s by default\n"
-msgstr ""
+msgstr "Utilisation par défaut du répertoire personnel dangereux `%s' pour %s refusée\n"
 
 #: ../apps/lnewusers.c:289
 #, c-format
@@ -407,9 +408,7 @@
 #: ../apps/lnewusers.c:318
 #, c-format
 msgid "Error creating mail spool for %s.\n"
-msgstr ""
-"Erreur lors de la création du répertoire de travail du client courriel pour %"
-"s.\n"
+msgstr "Erreur lors de la création du spool de courriel pour %s.\n"
 
 #: ../apps/lnewusers.c:324
 #, c-format
@@ -442,8 +441,7 @@
 #: ../apps/lpasswd.c:186 ../apps/luseradd.c:277 ../apps/luseradd.c:287
 #, c-format
 msgid "Error setting password for user %s: %s.\n"
-msgstr ""
-"Erreur lors de la définition du mot de passe pour l'utilisateur %s : %s.\n"
+msgstr "Erreur lors de la définition du mot de passe pour l'utilisateur %s : %s.\n"
 
 #: ../apps/lpasswd.c:195
 #, c-format
@@ -479,8 +477,7 @@
 #: ../apps/luseradd.c:326
 #, c-format
 msgid "Error creating mail spool.\n"
-msgstr ""
-"Erreur lors de la création du répertoire de travail du client courriel.\n"
+msgstr "Erreur lors de la création du spool de courriel.\n"
 
 #: ../apps/luserdel.c:94
 #, c-format
@@ -520,14 +517,12 @@
 #: ../apps/luserdel.c:158
 #, c-format
 msgid "Error removing mail spool.\n"
-msgstr ""
-"Erreur lors de la suppression du répertoire de travail du client courriel.\n"
+msgstr "Erreur lors de la suppression du spool de courriel.\n"
 
 #: ../apps/lusermod.c:164 ../apps/lusermod.c:177
 #, c-format
 msgid "Failed to set password for user %s: %s.\n"
-msgstr ""
-"Erreur lors de la définition du mot de passe pour l'utilisateur %s : %s.\n"
+msgstr "Erreur lors de la définition du mot de passe pour l'utilisateur %s : %s.\n"
 
 #: ../apps/lusermod.c:187
 #, c-format
@@ -782,7 +777,7 @@
 #: ../lib/user.c:1284
 #, c-format
 msgid "Refusing to use dangerous home directory `%s' by default"
-msgstr ""
+msgstr "Utilisation par défaut du répertoire personnel dangereux `%s' refusée"
 
 #: ../lib/user.c:1953
 #, c-format
@@ -1087,15 +1082,11 @@
 
 #: ../python/admin.c:689 ../python/admin.c:766
 msgid "error creating mail spool for user"
-msgstr ""
-"Erreur lors de la création du répertoire de travail du client courriel pour "
-"l'utilisateur"
+msgstr "Erreur lors de la création du spool de courriel pour l'utilisateur"
 
 #: ../python/admin.c:887
 msgid "error removing mail spool for user"
-msgstr ""
-"Erreur lors de la suppression du répertoire de travail du client courriel de "
-"l'utilisateur"
+msgstr "Erreur lors de la suppression du spool de courriel de l'utilisateur"
 
 #: ../samples/lookup.c:63
 #, c-format
@@ -1161,3 +1152,4 @@
 #, c-format
 msgid "Copying user structure:\n"
 msgstr "Copie de la structure de l'utilisateur :\n"
+