--- /home/sfriedma/Transifex/Fedora 12/Translatables/system-config-firewall  » master/system-config-firewall.master.fr_Old.po	2009-12-08 13:48:17.000000000 +1000
+++ /home/sfriedma/Transifex/Fedora 12/Translatables/system-config-firewall  » master/system-config-firewall.master.fr.po	2009-12-08 13:43:37.000000000 +1000
@@ -1,7 +1,7 @@
-# translation of system-config-firewall.master.po to french
+# translation of system-config-firewall.master.fr.po to French
 # translation of fr.po to
 # translation of fr.po to
-# Copyright (C) 2004, 2005, 2006, 2007, 2008 Free Software Foundation, Inc
+# Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009 Free Software Foundation, Inc
 #
 #
 # <>, 2006.
@@ -17,25 +17,25 @@
 # Thomas Canniot <mrtom@fedoraproject.org>, 2008, 2009.
 # Michael Ughetto <telimektar1er@gmail.com>, 2008.
 # Pablo Martin-Gomez <pablo.martin-gomez@laposte.net>, 2009.
+# Sam Friedmann <sam.friedmann@redhat.com>, 2009.
 msgid ""
 msgstr ""
-"Project-Id-Version: system-config-firewall.master\n"
+"Project-Id-Version: system-config-firewall.master.fr\n"
 "Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2009-12-08 02:29+0000\n"
-"PO-Revision-Date: 2009-09-19 15:24+0200\n"
-"Last-Translator: Thomas Canniot <mrtom@fedoraproject.org>\n"
-"Language-Team: French <fedora-trans-fr@redhat.com>\n"
+"PO-Revision-Date: 2009-12-08 13:43+1000\n"
+"Last-Translator: Sam Friedmann <sam.friedmann@redhat.com>\n"
+"Language-Team: French <fr@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Generator: Lokalize 1.0\n"
+"X-Generator: KBabel 1.11.4\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 
 #: ../config/org.fedoraproject.config.firewall.0.policy.in.h:1
 #: ../config/org.fedoraproject.config.firewall.policy.in.h:1
 msgid "Authentication is required to read and modify firewall settings"
-msgstr ""
-"Authentification requise pour lire et modifier les paramètres du pare-feu"
+msgstr "Authentification requise pour lire et modifier les paramètres du pare-feu"
 
 #: ../config/org.fedoraproject.config.firewall.0.policy.in.h:2
 #: ../config/org.fedoraproject.config.firewall.policy.in.h:2
@@ -218,13 +218,11 @@
 
 #: ../src/fw_gui.py:1134
 msgid "Please enter a valid port number, service name or range."
-msgstr ""
-"Veuillez donner un numéro de port, un nom de service ou un intervalle valide."
+msgstr "Veuillez donner un numéro de port, un nom de service ou un intervalle valide."
 
 #: ../src/fw_gui.py:1553
 msgid "There are unapplied changes, do you really want to quit?"
-msgstr ""
-"Des modifications n'ont pas été appliquées. Voulez-vous vraiment quitter ?"
+msgstr "Des modifications n'ont pas été appliquées. Voulez-vous vraiment quitter ?"
 
 #: ../src/fw_gui.py:1616
 #, python-format
@@ -299,8 +297,7 @@
 "existante sera écrasée. Êtes-vous sûr de vouloir poursuivre ?"
 
 #: ../src/fw_gui.py:2136 ../src/fw_tui.py:634
-msgid ""
-"Please remember to check if the services iptables and ip6tables are enabled."
+msgid "Please remember to check if the services iptables and ip6tables are enabled."
 msgstr ""
 "N'oubliez pas de vérifier que les services iptables et ip6tables sont "
 "activés."
@@ -556,8 +553,7 @@
 #: ../src/fw_parser.py:113
 #, python-format
 msgid "option %(option)s: invalid forward_port '%(value)s': %(error)s."
-msgstr ""
-"option %(option)s : port de réacheminement « %(value)s » invalide : %(error)s."
+msgstr "option %(option)s : port de réacheminement « %(value)s » invalide : %(error)s."
 
 #: ../src/fw_parser.py:124
 #, python-format
@@ -746,8 +742,7 @@
 
 #: ../src/fw_parser.py:391 ../src/fw_parser.py:430
 #, python-format
-msgid ""
-"Set firewall default type: %s. This overwrites any existing configuration."
+msgid "Set firewall default type: %s. This overwrites any existing configuration."
 msgstr ""
 "Choisir le type de pare-feu par défaut : %s. Ceci écrasera toute "
 "configuration existante."
@@ -1071,14 +1066,12 @@
 msgstr "Suite Red Hat Cluster"
 
 #: ../src/fw_services.py:173
-#, fuzzy
 msgid ""
 "This option allows you to use the Red Hat Cluster Suite. Ports are opened "
 "for openais, ricci and dlm. You need the Red Hat Cluster Suite installed for "
 "this option to be useful."
 msgstr ""
-"Cette option vous permet d'utiliser la suite Red Hat Cluster. Des ports sont "
-"ouverts pour openais, rgnamanager, ricci, dlm et cssd. Vous aurez besoin de "
+"Cette option vous permet d'utiliser la suite Red Hat Cluster. Des ports sont ouverts pour openais, ricci, et dlm. Vous aurez besoin de "
 "la suite Red Hat Cluster pour que cette option soit utile."
 
 #: ../src/fw_tui.py:46
@@ -1154,8 +1147,7 @@
 msgstr "Interfaces de confiance"
 
 #: ../src/fw_tui.py:107 ../src/system-config-firewall.glade.h:58
-msgid ""
-"Mark all interfaces as trusted which should have full access to the system."
+msgid "Mark all interfaces as trusted which should have full access to the system."
 msgstr ""
 "Marquer comme étant de confiance toutes les interfaces qui doivent avoir un "
 "accès complet au système."
@@ -1265,8 +1257,7 @@
 msgstr "Protocole :"
 
 #: ../src/fw_tui.py:400 ../src/system-config-firewall.glade.h:76
-msgid ""
-"Please select the source and destination options according to your needs."
+msgid "Please select the source and destination options according to your needs."
 msgstr ""
 "Veuillez sélectionner les options de source et de destination en fonction de "
 "vos besoins."
@@ -1386,8 +1377,7 @@
 msgstr "<b>Niveau de compétence utilisateur</b>"
 
 #: ../src/system-config-firewall.glade.h:7
-msgid ""
-"<b>Your current configuration is empty, all traffic will be blocked.</b>"
+msgid "<b>Your current configuration is empty, all traffic will be blocked.</b>"
 msgstr "<b>Votre pare-feu n'est pas configuré, tout trafic est bloqué.</b>"
 
 #: ../src/system-config-firewall.glade.h:8
@@ -1442,8 +1432,7 @@
 
 #: ../src/system-config-firewall.glade.h:22
 msgid "Configure firewall helper modules for connection tracking"
-msgstr ""
-"Configurer les modules d'assistance du pare-feu pour le suivi des connexions"
+msgstr "Configurer les modules d'assistance du pare-feu pour le suivi des connexions"
 
 #: ../src/system-config-firewall.glade.h:23
 msgid "Configure the iptables and ip6tables service settings."
@@ -1655,8 +1644,7 @@
 msgstr "Sélectionnez une entrée de la liste ou entrez un port et un protocole."
 
 #: ../src/system-config-firewall.glade.h:74
-msgid ""
-"Please select keep configuration or choose to load a default configuration."
+msgid "Please select keep configuration or choose to load a default configuration."
 msgstr ""
 "Veuillez sélectionner « garder la configuration actuelle » ou choisissez de "
 "charger une configuration par défaut."
@@ -1740,8 +1728,7 @@
 
 #: ../src/system-config-firewall.glade.h:97
 msgid "This program will help you to set up a basic firewall for your system."
-msgstr ""
-"Ce programme vous aidera à configurer un pare-feu de base pour votre système."
+msgstr "Ce programme vous aidera à configurer un pare-feu de base pour votre système."
 
 #: ../src/system-config-firewall.glade.h:98
 msgid ""
@@ -1769,8 +1756,7 @@
 
 #: ../src/system-config-firewall.glade.h:106
 msgid "You can change the settings in the <i>Options</i> menu afterwards."
-msgstr ""
-"Vous pourrez changer les paramètres plus tard depuis le menu <i>Options</i>."
+msgstr "Vous pourrez changer les paramètres plus tard depuis le menu <i>Options</i>."
 
 #: ../src/system-config-firewall.glade.h:107
 msgid "_About"
@@ -1815,5 +1801,3 @@
 "Alain Portal <dionysos AT fedoraproject DOT org>, 2007\n"
 "Gauthier Ancelin <gauthier.ancelin AT laposte DOT net>, 2007, 2008"
 
-#~ msgid "Helper modules:"
-#~ msgstr "Modules d'assistance :"