--- fedora-web.master-fedoraproject.it.po	2009-05-13 22:09:10.000000000 +0200
+++ fedora-web.master-fedoraproject.it.po.new	2009-05-13 22:04:32.000000000 +0200
@@ -8,16 +8,15 @@
 msgid ""
 msgstr ""
 "Project-Id-Version: fedora-web.master.it\n"
-"Report-Msgid-Bugs-To: EMAIL@ADDRESS\n"
+"Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2009-05-10 05:34-0400\n"
-"PO-Revision-Date: 2009-04-19 22:24+0200\n"
+"PO-Revision-Date: 2009-05-13 22:04+0200\n"
 "Last-Translator: mario_santagiuliana <mario at marionline.it>\n"
 "Language-Team: Italian <fedora-trans-it at redhat.com>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Plural-Forms:  nplurals=2; plural=(n != 1);\n"
-"X-Generator: Lokalize 0.3\n"
+"Plural-Forms:  nplurals=2; plural=(n != 1);"
 
 #: data/content/contact.html:7
 msgid "Contact - Fedora Project"
@@ -206,15 +205,14 @@
 "seguente codice dove si desidera che appaia il contatore:"
 
 #: data/content/counter.html:18
-#, fuzzy
 msgid ""
 "The lang parameter can be changed to display the counter in a different "
 "language.  Currently, the values de, en, hu, is, it, and pt-br are "
 "supported.  When no language is specified, English will be used."
 msgstr ""
 "Il parametro lang può essere cambiato per mostrare il contatore in una "
-"lingua differente.  Attualmente, sono supportati i valori en, es, it, e "
-"pt_BR.  Quando non è specificato alcun linguaggio, verrà utilizzato "
+"lingua differente.  Attualmente, sono supportati i valori de, en, hu, is, it e "
+"pt-br.  Quando non è specificato alcun linguaggio, verrà utilizzato "
 "l'inglese."
 
 #: data/content/get-fedora-all.html:13 data/content/get-fedora-kde.html:11
@@ -426,12 +424,11 @@
 "Fedora qui sotto."
 
 #: data/content/get-fedora-kde.html:23
-#, fuzzy
 msgid ""
 "Get Fedora 11 KDE Desktop Edition Now <em class=\"byline\">Installable Live "
 "CD</em>"
 msgstr ""
-"Ottieni Fedora 10 KDE Desktop Edition ora <em class=\"byline\">Live CD "
+"Ottieni Fedora 11 KDE Desktop Edition ora <em class=\"byline\">Live CD "
 "installabile</em>"
 
 #: data/content/get-fedora-kde.html:25 data/content/get-fedora-kde.html:45
@@ -441,16 +438,14 @@
 msgstr "Risorse"
 
 #: data/content/get-fedora-kde.html:27 data/content/get-fedora.html:22
-#, fuzzy
 msgid "Fedora 11 Installation Guide"
-msgstr "Guida all'installazione di Fedora 10"
+msgstr "Guida all'installazione di Fedora 11"
 
 #: data/content/get-fedora-kde.html:28 data/content/get-fedora-kde.html:48
 #: data/content/get-fedora-ppc.html:27 data/content/get-fedora.html:23
 #: data/content/get-fedora.html:43
-#, fuzzy
 msgid "Fedora 11 Release Notes"
-msgstr "Note di rilascio di Fedora 10"
+msgstr "Note di rilascio di Fedora 11"
 
 #: data/content/get-fedora-kde.html:29 data/content/get-fedora-kde.html:49
 #: data/content/get-fedora-ppc.html:28 data/content/get-fedora.html:24
@@ -482,12 +477,11 @@
 #: data/content/get-fedora-kde.html:38 data/content/get-fedora-kde.html:58
 #: data/content/get-fedora-ppc.html:37 data/content/get-fedora.html:33
 #: data/content/get-fedora.html:53
-#, fuzzy
 msgid ""
 "<a href=\"http://docs.fedoraproject.org/install-guide/f11/en_US/sn-making-"
 "media.html\">How do I use this file?</a>"
 msgstr ""
-"<a href=\"http://docs.fedoraproject.org/install-guide/f10/en_US/sn-making-"
+"<a href=\"http://docs.fedoraproject.org/install-guide/f11/en_US/sn-making-"
 "media.html\">Come uso questo file?</a>"
 
 #: data/content/get-fedora-kde.html:40 data/content/get-fedora-kde.html:60
@@ -497,29 +491,26 @@
 msgstr "Scarica ora!"
 
 #: data/content/get-fedora-kde.html:43 data/content/get-fedora.html:38
-#, fuzzy
 msgid "Upgrade to Fedora 11 from an older version"
-msgstr "Aggiorna a Fedora 10 da una vecchia versione"
+msgstr "Aggiorna a Fedora 11 da una versione precedente"
 
 #: data/content/get-fedora-kde.html:47 data/content/get-fedora.html:42
-#, fuzzy
 msgid ""
 "<a href=\"http://docs.fedoraproject.org/install-guide/f11/en_US/ch-upgrading-"
 "system.html\">Fedora 11 Upgrade Guide</a>"
 msgstr ""
-"<a href=\"http://docs.fedoraproject.org/install-guide/f10/en_US/ch-upgrading-"
-"system.html\">Guida all'aggiornamento a Fedora 10</a>"
+"<a href=\"http://docs.fedoraproject.org/install-guide/f11/en_US/ch-upgrading-"
+"system.html\">Guida all'aggiornamento a Fedora 11</a>"
 
 #: data/content/get-fedora-kde.html:55 data/content/get-fedora.html:50
-#, fuzzy
 msgid ""
 "Already have Fedora and want to upgrade to Fedora 11? Check out the <a href="
 "\"http://docs.fedoraproject.org/install-guide/f11/en_US/ch-upgrading-system."
 "html\">Upgrading Fedora</a> instructions, and download the DVD ISO you'll "
 "need to start the upgrade process below."
 msgstr ""
-"Avete già Fedora e volete aggiornarvi a Fedora 10? Guardate le istruzioni di "
-"<a href=\"http://docs.fedoraproject.org/install-guide/f10/en_US/ch-upgrading-"
+"Avete già Fedora e volete aggiornarvi a Fedora 11? Guardate le istruzioni di "
+"<a href=\"http://docs.fedoraproject.org/install-guide/f11/en_US/ch-upgrading-"
 "system.html\">Aggiornamento Fedora</a>, e scaricate la ISO DVD per avviare "
 "il processo di aggiornamento."
 
@@ -553,26 +544,23 @@
 "di Fedora che funzioni bene con il tuo computer."
 
 #: data/content/get-fedora-ppc.html:22
-#, fuzzy
 msgid "Install or Upgrade Fedora 11 for PowerPC"
-msgstr "Installare o aggiornare Fedora 10 per PowerPC"
+msgstr "Installare o aggiornare Fedora 11 per PowerPC"
 
 #: data/content/get-fedora-ppc.html:26
-#, fuzzy
 msgid ""
 "<a href=\"http://docs.fedoraproject.org/install-guide/f11/\">Fedora 11 "
 "Install Guide</a>"
 msgstr ""
-"<a href=\"http://docs.fedoraproject.org/install-guide/f10/\">Guida "
-"all'installazione di Fedora 10</a>"
+"<a href=\"http://docs.fedoraproject.org/install-guide/f11/\">Guida "
+"all'installazione di Fedora 11</a>"
 
 #: data/content/get-fedora-ppc.html:34
-#, fuzzy
 msgid ""
 "This is everything you need to install or upgrade to Fedora 11 on PowerPC "
 "machines!"
 msgstr ""
-"Questo è tutto ciò di cui hai bisogno per installare o aggiornare Fedora 10 "
+"Questo è tutto ciò di cui hai bisogno per installare o aggiornare Fedora 11 "
 "su macchine PowerPC!"
 
 #: data/content/get-fedora-ppc.html:37
@@ -582,12 +570,11 @@
 "%sGB, formato ISO, 1 immagine disco DVD per computer PowerPC-compatibili"
 
 #: data/content/get-fedora.html:18
-#, fuzzy
 msgid ""
 "Get Fedora 11 Desktop Edition Now <em class=\"byline\">Installable Live CD</"
 "em>"
 msgstr ""
-"Ottieni Fedora 10 Desktop Edition Ora <em class=\"byline\">Live CD "
+"Ottieni Fedora 11 Desktop Edition Ora <em class=\"byline\">Live CD "
 "Installabile</em>"
 
 #: data/content/get-fedora.html:30
@@ -601,14 +588,14 @@
 "se ti piace, per installarla direttamente dal tuo desktop!"
 
 #: data/content/get-fedora.html:33
-#, fuzzy, python-format
+#, python-format
 msgid "%sMB, ISO format, 1 CD-ROM disc image for Intel-compatible PCs (32-bit)"
-msgstr "%sMB, formato ISO, 1 immagine disco CD-ROM per PC Intel-compatibili"
+msgstr "%sMB, formato ISO, 1 immagine disco CD-ROM per PC Intel-compatibili (32 bit)"
 
 #: data/content/get-fedora.html:53
-#, fuzzy, python-format
+#, python-format
 msgid "%sGB, ISO format, 1 DVD disc image for Intel-compatible PCs (32-bit)"
-msgstr "%sGB, formato ISO, 1 immagine disco DVD per PC Intel-compatibili"
+msgstr "%sGB, formato ISO, 1 immagine disco DVD per PC Intel-compatibili (32 bit)"
 
 #: data/content/get-help.html:10
 msgid "Get Help."
@@ -777,7 +764,6 @@
 "\">docs.fedoraproject.org</a>."
 
 #: data/content/get-prerelease.html:13
-#, fuzzy
 msgid ""
 "This is pre-release software. The Fedora Project makes no guarantees as to "
 "its suitability or usefulness. All issues should be reported via the <a href="
@@ -786,21 +772,17 @@
 "Notes</a> for more information."
 msgstr ""
 "Questo è un software pre-release. Il Fedora Project non fornisce alcuna "
-"garanzia sulla sua idoneità o usabilità. Tutti i problemi dovrebbero essere "
-"riportati via <a href=\"https://bugzilla.redhat.com/\">Red Hat Bugzilla</a>. "
-"Leggere le <a href=\"https://fedoraproject.org/wiki/Fedora_11_Beta_ "
-"release_notes\">Note di rilascio della versione Beta</a> per maggiori "
+"garanzia sulla sua idoneità o usabilità. Tutti i problemi vanno riportati via <a href=\"https://bugzilla.redhat.com/\">Red Hat Bugzilla</a>. "
+"Leggere le <a href=\"https://docs.fedoraproject.org/release-notes/f11preview/\">Note di rilascio della versione Preview</a> per maggiori "
 "informazioni."
 
 #: data/content/index.html:10
-#, fuzzy
 msgid "Fedora 11: Reign."
-msgstr "Fedora 10"
+msgstr "Fedora 11: Regna."
 
 #: data/content/index.html:15
-#, fuzzy
 msgid "What's new in Fedora 11?  Read the release notes. &gt;&gt;"
-msgstr "Che c'è di nuovo in Fedora 10? Leggete le note di rilascio. &gt;&gt;"
+msgstr "Che c'è di nuovo in Fedora 11? Leggete le note di rilascio. &gt;&gt;"
 
 #: data/content/index.html:18
 msgid ""
@@ -1067,22 +1049,20 @@
 msgstr "Chiavi attualmente usate"
 
 #: data/content/keys.html:67 data/content/keys.html:80
-#, fuzzy
 msgid ""
 "Download: <a href=\"https://fedoraproject.org/static/D22E77F2.txt\">Fedora "
 "Project</a>"
 msgstr ""
-"Download: <a href=\"https://fedoraproject.org/static/4EBFC273.txt\">Fedora "
+"Download: <a href=\"https://fedoraproject.org/static/D22E77F2.txt\">Fedora "
 "Project</a>"
 
 #: data/content/keys.html:68 data/content/keys.html:81
-#, fuzzy
 msgid ""
 "Download: <a href=\"http://keys.gnupg.net:11371/pks/lookup?"
 "search=0xD22E77F2&op=get\">keys.gnupg.net</a>"
 msgstr ""
-"Download: <a href=\"http://keys.gnupg.net:11371/pks/lookup?"
-"search=0x4EBFC273&op=get\">keys.gnupg.net</a>"
+"Download:·<a·href=\"http://keys.gnupg.net:11371/pks/lookup?"
+"search=0xD22E77F2&op=get\">keys.gnupg.net</a>"
 
 #: data/content/keys.html:94
 msgid ""
@@ -1318,7 +1298,6 @@
 "burning-isos/en_US/sn-validating-files.html\">queste istruzioni</a>."
 
 #: data/content/verify.html:15
-#, fuzzy
 msgid ""
 "Once you have downloaded an ISO, verify it for security and integrity.  If "
 "you downloaded your ISO via BitTorrent, the file has already been verified "
@@ -1331,7 +1310,7 @@
 "scaricato l'ISO via BitTorrent, il file è già stato verificato come parte "
 "del processo di download (assicurati solo di aver scaricato via torrent da "
 "<a href=\"http://torrent.fedoraproject.org/\">torrent.fedoraproject.org</"
-"a>).  Altrimenti, per verificare l'ISO, inizia scaricando il file SHA1SUM "
+"a>).  Altrimenti, per verificare l'ISO, inizia scaricando il file CHECKSUM "
 "appropriato nella stessa directory della ISO:"
 
 #: data/content/verify.html:17
@@ -1354,23 +1333,20 @@
 "Si può verificare i dettagli della chiave GPG <a href=\"%s/%s/keys\">qui</a>."
 
 #: data/content/verify.html:37
-#, fuzzy
 msgid "Now, verify that the CHECKSUM file is valid:"
-msgstr "Ora, verificare che il file SHA1SUM sia valido:"
+msgstr "Ora, verificare che il file CHECKSUM sia valido:"
 
 #: data/content/verify.html:41
-#, fuzzy
 msgid ""
 "The CHECKSUM file should have a good signature from one of the following "
 "keys:"
 msgstr ""
-"Il file SHA1SUM dovrebbe avere una firma verificata per una delle seguenti "
+"Il file CHECKSUM dovrebbe avere una firma verificata da una delle seguenti "
 "chiavi:"
 
 #: data/content/verify.html:44
-#, fuzzy
 msgid "Fedora 11"
-msgstr "Fedora 10"
+msgstr "Fedora 11"
 
 #: data/content/verify.html:45
 msgid "Fedora 10"
@@ -1389,12 +1365,11 @@
 msgstr "Fedora 9 e pre-release precedenti"
 
 #: data/content/verify.html:51
-#, fuzzy
 msgid ""
 "Finally, now that the CHECKSUM file has been verified, check that the ISO's "
 "checksum matches:"
 msgstr ""
-"In fine, ora che il file SHA1SUM è stato verificato, controlla che il "
+"In fine, ora che il file CHECKSUM è stato verificato, controlla che il "
 "checksum della ISO coincida:"
 
 #: data/content/verify.html:55
@@ -1501,9 +1476,9 @@
 msgstr "%s/static/images/counter/%s"
 
 #: data/templates/sidebar.html:26
-#, fuzzy, python-format
+#, python-format
 msgid "Fedora 11 Leonidas released in %s days!"
-msgstr "Fedora 10 Cambridge rilasciato tra %s giorni!"
+msgstr "Fedora 11 Leonidas rilasciato tra %s giorni!"
 
 #: data/templates/sidebar.html:27
 msgid "Add a counter to your own site!"