From be2111659beb31b5b81e8554fcfa5bff84352bc1 Mon Sep 17 00:00:00 2001
From: Stephen Smoogen <smooge@redhat.com>
Date: Wed, 20 Mar 2019 13:52:08 +0000
Subject: [PATCH 1/2] [multiple updates] Add in drives45 to hand over to Kevin
 for 45drives evaluation. Remove ipv6 from inventory so system can be cleaned
 out. This box should never have been on the frozen category.

No idea why that file got renamed.
---
 inventory/hardware                              |  4 +++
 inventory/host_vars/ipv6-test.fedoraproject.org | 27 ------------------
 inventory/inventory                             |  5 ++--
 playbooks/groups/nfs-servers.yml                | 38 +++++++++++++++++++++++++
 playbooks/hosts/ipv6-test.fedoraproject.org.yml | 32 ---------------------
 5 files changed, 44 insertions(+), 62 deletions(-)
 delete mode 100644 inventory/host_vars/ipv6-test.fedoraproject.org
 create mode 100644 playbooks/groups/nfs-servers.yml
 delete mode 100644 playbooks/hosts/ipv6-test.fedoraproject.org.yml

diff --git a/inventory/hardware b/inventory/hardware
index ec5ad89..507f32a 100644
--- a/inventory/hardware
+++ b/inventory/hardware
@@ -140,6 +140,8 @@ buildhw-aarch64-07.arm.fedoraproject.org
 buildhw-aarch64-08.arm.fedoraproject.org
 autocloud-backend-aarch64.arm.fedoraproject.org
 
+[45drives]
+drives45-01.phx2.fedoraproject.org
 
 [hardware:children]
 moonshot
@@ -147,3 +149,5 @@ powerpc
 dells
 ibms
 appliedmicro
+45drives
+
diff --git a/inventory/host_vars/ipv6-test.fedoraproject.org b/inventory/host_vars/ipv6-test.fedoraproject.org
deleted file mode 100644
index 34df2ce..0000000
--- a/inventory/host_vars/ipv6-test.fedoraproject.org
+++ /dev/null
@@ -1,27 +0,0 @@
----
-nrpe_procs_warn: 900
-nrpe_procs_crit: 1000
-eth0_ip: 8.43.85.71
-eth0_nm: 255.255.255.0
-gw: 8.43.85.254
-nm: 255.255.255.0
-dns: 8.8.8.8
-deployment_type: prod
-
-volgroup: /dev/vg_guests
-vmhost: virthost-cc-rdu03.fedoraproject.org
-datacenter: rdu-cc
-
-fas_client_groups: sysadmin-troubleshoot
-
-has_ipv6: yes
-eth0_ipv6: "2620:52:3:1:dead:beef:cafe:fed0"
-eth0_ipv6_gw: "2620:52:3:1:ffff:ffff:ffff:fffe"
-
-vpn: false
-
-
-ks_url: http://209.132.181.6/repo/rhel/ks/kvm-rhel-7-ext
-ks_repo: http://209.132.181.6/repo/rhel/RHEL7-x86_64/
-
-host_backup_targets: ['/srv']
diff --git a/inventory/inventory b/inventory/inventory
index d523d96..dbcd562 100644
--- a/inventory/inventory
+++ b/inventory/inventory
@@ -1513,7 +1513,6 @@ retrace01.qa.fedoraproject.org
 
 [rhel8beta]
 el8betatest01.stg.phx2.fedoraproject.org
-#osuosl03.fedoraproject.org
 
-[ipv6-test]
-ipv6-test.fedoraproject.org
+[nfs-servers]
+drives45-01.phx2.fedoraproject.org
diff --git a/playbooks/groups/nfs-servers.yml b/playbooks/groups/nfs-servers.yml
new file mode 100644
index 0000000..801f47e
--- /dev/null
+++ b/playbooks/groups/nfs-servers.yml
@@ -0,0 +1,38 @@
+# This is a basic playbook
+
+- name: dole out the basic configuration
+  hosts: nfs-servers
+  user: root
+  gather_facts: True
+
+  vars_files:
+   - /srv/web/infra/ansible/vars/global.yml
+   - "/srv/private/ansible/vars.yml"
+   - /srv/web/infra/ansible/vars/{{ ansible_distribution }}.yml
+
+  pre_tasks:
+  - import_tasks: "{{ tasks_path }}/yumrepos.yml"
+
+  roles:
+  - base
+  - rkhunter
+  - hosts
+  - fas_client
+  - nagios_client
+  - collectd/base
+  - sudo
+
+  tasks:
+  - import_tasks: "{{ tasks_path }}/2fa_client.yml"
+  - import_tasks: "{{ tasks_path }}/motd.yml"
+
+  handlers:
+  - import_tasks: "{{ handlers_path }}/restart_services.yml"
+
+- name: dole out the NFS configuration
+  hosts: nfs-servers
+  user: root
+  gather_facts: True
+
+  role:
+  - nfs/server
diff --git a/playbooks/hosts/ipv6-test.fedoraproject.org.yml b/playbooks/hosts/ipv6-test.fedoraproject.org.yml
deleted file mode 100644
index e3065bd..0000000
--- a/playbooks/hosts/ipv6-test.fedoraproject.org.yml
+++ /dev/null
@@ -1,32 +0,0 @@
-# This is a basic playbook
-
-- import_playbook: "/srv/web/infra/ansible/playbooks/include/virt-create.yml myhosts=ipv6-test"
-
-- name: make the boxen be real for real
-  hosts: ipv6-test
-  user: root
-  gather_facts: True
-
-  vars_files:
-   - /srv/web/infra/ansible/vars/global.yml
-   - "/srv/private/ansible/vars.yml"
-   - /srv/web/infra/ansible/vars/{{ ansible_distribution }}.yml
-
-  roles:
-  - base
-  - rkhunter
-  - hosts
-  - fas_client
-  - nagios_client
-  - collectd/base
-  - sudo
-
-  pre_tasks:
-  - import_tasks: "{{ tasks_path }}/yumrepos.yml"
-
-  tasks:
-  - import_tasks: "{{ tasks_path }}/2fa_client.yml"
-  - import_tasks: "{{ tasks_path }}/motd.yml"
-
-  handlers:
-  - import_tasks: "{{ handlers_path }}/restart_services.yml"
-- 
1.8.3.1