diff --git a/cobbler/kickgen.py b/cobbler/kickgen.py
index 9a8e146..449c2b5 100644
--- a/cobbler/kickgen.py
+++ b/cobbler/kickgen.py
@@ -111,6 +111,14 @@ class KickGen:
         saveks = "\nwget \"http://%s/cblr/svc/op/ks/%s/%s\" -O /root/cobbler.ks"
         runpost = "\nwget \"http://%s/cblr/svc/op/trig/mode/post/%s/%s\" -O /dev/null"
         runpre  = "\nwget \"http://%s/cblr/svc/op/trig/mode/pre/%s/%s\" -O /dev/null"
+        deb_nopxe = "d-i preseed/early_command string wget \"http://%s/cblr/svc/op/nopxe/system/%s\" -O /dev/null"
+        deb_saveks = "d-i preseed/early_command string wget \"http://%s/cblr/svc/op/ks/%s/%s\" -O /root/cobbler.ks"
+        deb_runpost = "d-i preseed/early_command string wget \"http://%s/cblr/svc/op/trig/mode/post/%s/%s\" -O /dev/null"
+        deb_runpre  = "d-i preseed/early_command string wget \"http://%s/cblr/svc/op/trig/mode/pre/%s/%s\" -O /dev/null"
+        suse_nopxe = "\nwget \"http://%s/cblr/svc/op/nopxe/system/%s\" -O /dev/null"
+        suse_saveks = "\nwget \"http://%s/cblr/svc/op/ks/%s/%s\" -O /root/cobbler.ks"
+        suse_runpost = "\nwget \"http://%s/cblr/svc/op/trig/mode/post/%s/%s\" -O /dev/null"
+        suse_runpre  = "\nwget \"http://%s/cblr/svc/op/trig/mode/pre/%s/%s\" -O /dev/null"
 
         what = "profile"
         blend_this = profile
@@ -123,29 +131,81 @@ class KickGen:
 
         buf = ""
         srv = blended["http_server"]
-        if system is not None:
-            if not is_pre:
-                if str(self.settings.pxe_just_once).upper() in [ "1", "Y", "YES", "TRUE" ]:
-                    buf = buf + nopxe % (srv, system.name)
-                if kickstart and os.path.exists(kickstart):
-                    buf = buf + saveks % (srv, "system", system.name)
-                if self.settings.run_install_triggers:
-                    buf = buf + runpost % (srv, what, system.name)
+        if self.breed == "redhat"
+            if system is not None:
+                if not is_pre:
+                    if str(self.settings.pxe_just_once).upper() in [ "1", "Y", "YES", "TRUE" ]:
+                        buf = buf + nopxe % (srv, system.name)
+                    if kickstart and os.path.exists(kickstart):
+                        buf = buf + saveks % (srv, "system", system.name)
+                    if self.settings.run_install_triggers:
+                        buf = buf + runpost % (srv, what, system.name)
+                else:
+                    if self.settings.run_install_triggers:
+                        buf = buf + runpre % (srv, what, system.name)
+
             else:
-                if self.settings.run_install_triggers:
-                    buf = buf + runpre % (srv, what, system.name)
+                if not is_pre:
+                    if kickstart and os.path.exists(kickstart):
+                        buf = buf + saveks % (srv, "profile", profile.name)
+                    if self.settings.run_install_triggers:
+                        buf = buf + runpost % (srv, what, profile.name) 
+                else:
+                    if self.settings.run_install_triggers:
+                        buf = buf + runpre % (srv, what, profile.name) 
+
+            return buf
+        elif self.breed == "debian"
+            if system is not None:
+                if not is_pre:
+                    if str(self.settings.pxe_just_once).upper() in [ "1", "Y", "YES", "TRUE" ]:
+                        buf = buf + deb_nopxe % (srv, system.name)
+                    if kickstart and os.path.exists(kickstart):
+                        buf = buf + deb_saveks % (srv, "system", system.name)
+                    if self.settings.run_install_triggers:
+                        buf = buf + deb_runpost % (srv, what, system.name)
+                else:
+                    if self.settings.run_install_triggers:
+                        buf = buf + deb_runpre % (srv, what, system.name)
 
-        else:
-            if not is_pre:
-                if kickstart and os.path.exists(kickstart):
-                    buf = buf + saveks % (srv, "profile", profile.name)
-                if self.settings.run_install_triggers:
-                    buf = buf + runpost % (srv, what, profile.name) 
             else:
-                if self.settings.run_install_triggers:
-                    buf = buf + runpre % (srv, what, profile.name) 
+                if not is_pre:
+                    if kickstart and os.path.exists(kickstart):
+                        buf = buf + deb_saveks % (srv, "profile", profile.name)
+                    if self.settings.run_install_triggers:
+                        buf = buf + deb_runpost % (srv, what, profile.name) 
+                else:
+                    if self.settings.run_install_triggers:
+                        buf = buf + deb_runpre % (srv, what, profile.name) 
+
+            return buf
+
+        elif self.breed == "suse"
+            if system is not None:
+                if not is_pre:
+                    if str(self.settings.pxe_just_once).upper() in [ "1", "Y", "YES", "TRUE" ]:
+                        buf = buf + suse_nopxe % (srv, system.name)
+                    if kickstart and os.path.exists(kickstart):
+                        buf = buf + suse_saveks % (srv, "system", system.name)
+                    if self.settings.run_install_triggers:
+                        buf = buf + suse_runpost % (srv, what, system.name)
+                else:
+                    if self.settings.run_install_triggers:
+                        buf = buf + suse_runpre % (srv, what, system.name)
+
+            else:
+                if not is_pre:
+                    if kickstart and os.path.exists(kickstart):
+                        buf = buf + suse_saveks % (srv, "profile", profile.name)
+                    if self.settings.run_install_triggers:
+                        buf = buf + suse_runpost % (srv, what, profile.name) 
+                else:
+                    if self.settings.run_install_triggers:
+                        buf = buf + suse_runpre % (srv, what, profile.name) 
+
+            return buf
+        # end if for breed
 
-        return buf
 
     def generate_repo_stanza(self, obj, is_profile=True):
 